#2009/01/01 公開
#各自の責任の下ご利用下さい。

require 'sketchup.rb'

class RSroomshell
  def rsroomshell_default_settings
    $room_h = 2400.mm if not $room_h
    $habaki_h = 60.mm if not $habaki_h
    $mawaributi_h = 25.mm if not $mawaributi_h
    $yukashita_h = 0.mm if not $yukashita_h
    $rstenba = 900.mm if not $rstenba
    $rsthickness = 30.mm if not $rsthickness
    $rstenba2 = 1100.mm if not $rstenba2
    $rsthickness2 = 25.mm if not $rsthickness2
    $totsu_h = 450.mm if not $totsu_h
    $tenjou = 1 if not $tenjou
    $rs_yuka_m = "214,177,106" if not $rs_yuka_m        #床
    $rs_habaki_m = "215,177,106" if not $rs_habaki_m    #巾木
    $rs_kabe_m = "240,240,240" if not $rs_kabe_m        #壁
    $rs_futi_m = "215,177,106" if not $rs_futi_m        #回り縁
    $rs_ceil_m = "238,238,238" if not $rs_ceil_m        #天井
    $rs_parts_m = "225,185,119" if not $rs_parts_m      #棚板
    $rs_parts2_m = "225,185,119" if not $rs_parts2_m    #天板
  end
  
  def rsroomshell_shelf
    model = Sketchup.active_model
    model.start_operation "rsroomshell_shelf"
    entities = model.active_entities
    ss = model.selection
    # デフォルト設定
    rsroomshell_default_settings
    # ダイアログ
    prompts = ["天端高さ","厚み","床下","天板(R,G,B)or(名前)"]
    values = [$rstenba,$rsthickness,$yukashita_h,$rs_parts_m]
    results = inputbox prompts, values, "パーツパラメータ"
    return if not results
    $rstenba,$rsthickness,$yukashita_h,$rs_parts_m = results
    rs_parts_mtrl=$rs_parts_m
    # マテリアル設定
    if rs_parts_mtrl.index(",")
      rgb=[]
      rgb = rs_parts_mtrl.split(",")
      rs_parts_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    entities=model.active_entities.add_group.entities
    for obj in ss
      #上下面描画
      if obj.typename == "Face"
        getface=[]
        for p in obj.vertices
          getface << p.position + [0,0,$rstenba+$yukashita_h]
        end # for
        face=entities.add_face getface
        face.material = face.back_material = rs_parts_mtrl
        getface=[]
        for p in obj.vertices
          getface << p.position + [0,0,$rstenba-$rsthickness+$yukashita_h]
        end # for
        face=entities.add_face getface
        face.material = face.back_material = rs_parts_mtrl
      end # if
      if obj.typename == "Edge"
        pts = obj.vertices
        p1 = pts[0].position
        p2 = pts[1].position
        #木口描画
        if $rsthickness > 0 
          pt=[]
          pt<<[p1.x,p1.y,p1.z+$rstenba+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$rstenba+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$rstenba-$rsthickness+$yukashita_h]
          pt<<[p1.x,p1.y,p1.z+$rstenba-$rsthickness+$yukashita_h]
          face=entities.add_face pt
          face.material = face.back_material = rs_parts_mtrl
        end # if
      end # if
    end # for
    #元要素削除
    for tmp in ss
      if tmp.typename == "Edge"
        tmp.erase!
      end # if
    end # for
    model.commit_operation
  end# of def
  
  def rsroomshell_halfwall
    model = Sketchup.active_model
    model.start_operation "rsroomshell_halfwall"
    entities = model.active_entities
    ss = model.selection
    # デフォルト設定
    rsroomshell_default_settings
    # ダイアログ
    prompts = ["天端高さ","厚み","床下","笠木(R,G,B)or(名前)","腰壁(R,G,B)or(名前)"]
    values = [$rstenba2,$rsthickness2,$yukashita_h,$rs_parts2_m,$rs_kabe_m]
    results = inputbox prompts, values, "パーツパラメータ"
    return if not results
    $rstenba2,$rsthickness2,$yukashita_h,$rs_parts2_m,$rs_kabe_m = results
    rs_parts2_mtrl=$rs_parts2_m
    # マテリアル設定
    if rs_parts2_mtrl.index(",")
      rgb=[]
      rgb = rs_parts2_mtrl.split(",")
      rs_parts2_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    rs_kabe_mtrl=$rs_kabe_m
    if rs_kabe_mtrl.index(",")
      rgb=[]
      rgb = rs_kabe_mtrl.split(",")
      rs_kabe_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    pt=[]
    entities=model.active_entities.add_group.entities
    for obj in ss
      #Faceを探して上面描画
      if obj.typename == "Face"
        getface=[]
        for p in obj.vertices
          getface << p.position + [0,0,$rstenba2+$yukashita_h]
        end # for
        face=entities.add_face getface
        if $rsthickness2 > 0
          face.material = face.back_material = rs_parts2_mtrl
        else
          face.material = face.back_material = rs_kabe_mtrl
        end # if
      end # if
      if obj.typename == "Edge"
        pts = obj.vertices
        p1 = pts[0].position
        p2 = pts[1].position
        #Edgeを探して側面描画
        #厚みがゼロ以上で天板木口を描画
        if $rsthickness2 > 0
          pt=[]
          pt<<[p1.x,p1.y,p1.z+$rstenba2+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$rstenba2+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$rstenba2-$rsthickness2+$yukashita_h]
          pt<<[p1.x,p1.y,p1.z+$rstenba2-$rsthickness2+$yukashita_h]
          face=entities.add_face pt
          face.material = face.back_material = rs_parts2_mtrl
        end # if
        #腰壁を描画
        pt=[]
        pt<<[p1.x,p1.y,p1.z+$yukashita_h]
        pt<<[p2.x,p2.y,p2.z+$yukashita_h]
        pt<<[p2.x,p2.y,p2.z+$rstenba2-$rsthickness2+$yukashita_h]
        pt<<[p1.x,p1.y,p1.z+$rstenba2-$rsthickness2+$yukashita_h]
        face=entities.add_face pt
        face.material = face.back_material = rs_kabe_mtrl
      end # if
    end # for
    #元要素削除
    for tmp in ss
      if tmp.typename == "Edge"
        tmp.erase!
      end
    end
    model.commit_operation
  end # def
  
  def rsroomshell_girder
    model = Sketchup.active_model
    model.start_operation "rsroomshell_girder"
    entities = model.active_entities
    ss = model.selection
    # デフォルト設定
    rsroomshell_default_settings
    # ダイアログ
    prompts = ["天井高","廻り縁","凸せい","床下","壁(R,G,B)or(名前)","廻り縁(R,G,B)or(名前)"]
    values = [$room_h,$mawaributi_h,$totsu_h,$yukashita_h,$rs_kabe_m,$rs_futi_m]
    results = inputbox prompts, values, "凸パラメータ"
    return if not results
    $room_h,$mawaributi_h,$totsu_h,$yukashita_h,$rs_kabe_m,$rs_futi_m = results
    rs_kabe_mtrl= $rs_kabe_m
    rs_futi_mtrl= $rs_futi_m
    # マテリアル設定
    if rs_kabe_mtrl.index(",")
      rgb=[]
      rgb = rs_kabe_mtrl.split(",")
      rs_kabe_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    if rs_futi_mtrl.index(",")
      rgb=[]
      rgb = rs_futi_mtrl.split(",")
      rs_futi_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    pt=[]
    entities=model.active_entities.add_group.entities
    for obj in ss
      #底描画
      if obj.typename == "Face"
        getface=[]
        for p in obj.vertices
          getface << p.position + [0,0,$room_h-$totsu_h+$yukashita_h]
        end # for
        face=entities.add_face getface
        face.material = face.back_material =  rs_kabe_mtrl
      end # if
      if obj.typename == "Edge"
        pts = obj.vertices
        p1 = pts[0].position
        p2 = pts[1].position
        #側面描画
        pt=[]
        pt<<[p1.x,p1.y,p1.z+$room_h-$totsu_h+$yukashita_h]
        pt<<[p2.x,p2.y,p2.z+$room_h-$totsu_h+$yukashita_h]
        pt<<[p2.x,p2.y,p2.z+$room_h-$mawaributi_h+$yukashita_h]
        pt<<[p1.x,p1.y,p1.z+$room_h-$mawaributi_h+$yukashita_h]
        face=entities.add_face pt
        face.material = face.back_material =  rs_kabe_mtrl
        #廻り縁描画
        if $mawaributi_h >0 
          pt=[]
          pt<<[p1.x,p1.y,p1.z+$room_h+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$room_h+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$room_h-$mawaributi_h+$yukashita_h]
          pt<<[p1.x,p1.y,p1.z+$room_h-$mawaributi_h+$yukashita_h]
          face=entities.add_face pt
          face.material = face.back_material = rs_futi_mtrl
        end # if
      end # if
    end # for
    #元要素削除
    for tmp in ss
      if tmp.typename == "Edge"
        tmp.erase!
      end
    end
    model.commit_operation
  end# of def
  
  def rsroomshell_shell
    model = Sketchup.active_model
    model.start_operation "rsroomshell_shell"
    entities = model.active_entities
    ss = model.selection
    # デフォルト設定
    rsroomshell_default_settings
    # ダイアログ
    prompts = ["天井高","巾木","廻り縁","床下","天井の描画(0=無,1=有)","床(R,G,B)or(名前)","巾木(R,G,B)or(名前)","壁(R,G,B)or(名前)","廻り縁(R,G,B)or(名前)","天井(R,G,B)or(名前)"]
    values = [$room_h,$habaki_h,$mawaributi_h,$yukashita_h,$tenjou,$rs_yuka_m,$rs_habaki_m,$rs_kabe_m,$rs_futi_m,$rs_ceil_m]
    results = inputbox prompts, values, "シェルパラメータ"
    return if not results
    $room_h,$habaki_h,$mawaributi_h,$yukashita_h,$tenjou,$rs_yuka_m,$rs_habaki_m,$rs_kabe_m,$rs_futi_m,$rs_ceil_m = results
    rs_yuka_mtrl=$rs_yuka_m
    rs_habaki_mtrl= $rs_habaki_m
    rs_kabe_mtrl= $rs_kabe_m
    rs_futi_mtrl= $rs_futi_m
    rs_ceil_mtrl= $rs_ceil_m
    # マテリアル設定
    if rs_yuka_mtrl.index(",")
      rgb=[]
      rgb = rs_yuka_mtrl.split(",")
      rs_yuka_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    if rs_habaki_mtrl.index(",")
      rgb=[]
      rgb = rs_habaki_mtrl.split(",")
      rs_habaki_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    if rs_kabe_mtrl.index(",")
      rgb=[]
      rgb = rs_kabe_mtrl.split(",")
      rs_kabe_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    if rs_futi_mtrl.index(",")
      rgb=[]
      rgb = rs_futi_mtrl.split(",")
      rs_futi_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    if rs_ceil_mtrl.index(",")
      rgb=[]
      rgb = rs_ceil_mtrl.split(",")
      rs_ceil_mtrl=Sketchup::Color.new(rgb[0].to_i,rgb[1].to_i,rgb[2].to_i)
    end # if
    pt=[]
    entities=model.active_entities.add_group.entities
    for obj in ss
      #床描画
      if obj.typename == "Face" 
        getface=[]
        for p in obj.vertices
          getface << p.position + [0,0,$yukashita_h]
        end # for
        face=entities.add_face getface
        face.material = face.back_material = rs_yuka_mtrl
      end # if
      if obj.typename == "Edge" 
        pts = obj.vertices
        p1 = pts[0].position
        p2 = pts[1].position
        #巾木描画
        if $habaki_h > 0 
          pt=[]
          pt<<[p1.x,p1.y,p1.z+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$habaki_h+$yukashita_h]
          pt<<[p1.x,p1.y,p1.z+$habaki_h+$yukashita_h]
          face=entities.add_face pt
          face.material = face.back_material = rs_habaki_mtrl
        end # if
        #壁描画
        pt=[]
        pt<<[p1.x,p1.y,p1.z+$habaki_h+$yukashita_h]
        pt<<[p2.x,p2.y,p2.z+$habaki_h+$yukashita_h]
        pt<<[p2.x,p2.y,p2.z+$room_h-$mawaributi_h+$yukashita_h]
        pt<<[p1.x,p1.y,p1.z+$room_h-$mawaributi_h+$yukashita_h]
        face=entities.add_face pt
        face.material = face.back_material = rs_kabe_mtrl
        #廻り縁描画
        if $mawaributi_h >0 
          pt=[]
          pt<<[p1.x,p1.y,p1.z+$room_h+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$room_h+$yukashita_h]
          pt<<[p2.x,p2.y,p2.z+$room_h-$mawaributi_h+$yukashita_h]
          pt<<[p1.x,p1.y,p1.z+$room_h-$mawaributi_h+$yukashita_h]
          face=entities.add_face pt
          face.material = face.back_material = rs_futi_mtrl
        end # if
      end # if
    end # for
    entities=model.active_entities.add_group.entities
    if $tenjou==1
      #天井描画
      for obj in ss
        if obj.typename == "Face"
          getface=[]
          for p in obj.vertices
            getface << p.position + [0,0,$yukashita_h+$room_h]
          end # for
          face=entities.add_face getface
          face.material = face.back_material = rs_ceil_mtrl
        end # if
      end # for
    end # if
    #元要素削除
    entities.erase_entities ss
    model.commit_operation
  end# def
  #////////////////////////////////////////
  #////////////  本体設定  ////////////////
  #////////////////////////////////////////
  unless ( file_loaded?("RSroomshell.rb") )
    # ツールバー
    plugins = Sketchup.find_support_file("Plugins")
    imgdir = File.join(plugins, "rsico")
    tb = UI::Toolbar.new("RSroomshell")
    cmd = UI::Command.new("棚板") { RSroomshell.new.rsroomshell_shelf }
    cmd.large_icon =  cmd.small_icon = File.join(imgdir, "rsroomparts.png")
    cmd.status_bar_text = cmd.tooltip = "棚板"
    tb.add_item cmd
    cmd = UI::Command.new("腰壁") { RSroomshell.new.rsroomshell_halfwall }
    cmd.large_icon =  cmd.small_icon = File.join(imgdir, "rsroomparts2.png")
    cmd.status_bar_text = cmd.tooltip = "腰壁"
    tb.add_item cmd
    cmd = UI::Command.new("梁型") { RSroomshell.new.rsroomshell_girder }
    cmd.large_icon =  cmd.small_icon = File.join(imgdir, "RStotsu.png")
    cmd.status_bar_text = cmd.tooltip = "梁型"
    tb.add_item cmd
    cmd = UI::Command.new("部屋シェル") { RSroomshell.new.rsroomshell_shell }
    cmd.large_icon =  cmd.small_icon = File.join(imgdir, "roomshell.png")
    cmd.status_bar_text = cmd.tooltip = "部屋シェル"
    tb.add_item cmd
    tb.show if tb.get_last_state == -1
  end
  # コマンド
  if not file_loaded?("RSroomshell.rb")
    add_separator_to_menu("Plugins")
    UI.menu("Plugins").add_item("RS棚板") { rsroomshell_shelf }
    UI.menu("Plugins").add_item("RS腰壁") { rsroomshell_halfwall }
    UI.menu("Plugins").add_item("RS梁型") { rsroomshell_girder }
    UI.menu("Plugins").add_item("RS部屋シェル") { rsroomshell_shell }
  end
  #-------------------------------------------------------------------------
  file_loaded("RSroomshell.rb")
end #of class